var contextMenuId = "ContextMenuOtherHistoryItems";
var contextMenuWrapper = $("ContextMenuOtherHistoryItems");
var mouseOverContextMenu = false;   // is the mouse over the context menu?
var contextMenuVisible = false;
var autohideCounter = 0;
var contextMenuEnabled = true;
var AUTOHIDE_MS = 10000;

function InitContext()
{
    contextMenuWrapper.onmouseover = function() { mouseOverContextMenu = true; };
    contextMenuWrapper.onmouseout = function() { mouseOverContextMenu = false; };
    
    document.body.onmousedown = ContextMenuMouseDown;
    document.body.oncontextmenu = ContextMenuShow;
    document.body.onmouseup = ContextMenuHide;
}

function SetContextMenu(contextMenu)
{
    ContextMenuHide();
    contextMenuId = contextMenu;
    contextMenuWrapper = $(contextMenu);
}

function GetContextMenu()
{
    return contextMenuId;
}

function EnableContextMenu(enabled)
{
    contextMenuEnabled = enabled;
}

function ResolveWindowEvent(event)
{
    if (event != null)
        return event;
    else if (window.event != null)
        return window.event;
    else if (window.window.event != null)
        return window.window.event;
    else
        return null;
}

function Target(event)
{
    return event.target != null ? event.target : event.srcElement;
}

// call from the onMouseDown event
function ContextMenuMouseDown()
{
    // helps hiding of the context menu
}

// call from the onContextMenu event
// if this function returns false, the gadget's default context menu will not show up
function ContextMenuShow()
{
    if (mouseOverContextMenu || !contextMenuEnabled)
        return false;

    var event = ResolveWindowEvent(event);
    var target = Target(event);
    
    if (target.contextMenu == "true") // show context menu
    {
        contextMenuWrapper.style.display = 'none';
        PlaceContextMenu(event.clientX, event.clientY)
        contextMenuWrapper.style.display = 'block';        
        contextMenuVisible = true;

        //Autohide after AUTOHIDE_MS miliseconds
        AutoHideAfterX(AUTOHIDE_MS)
        return false;
    }
    else if (target.contextMenu == "false")
        return false; // show nothing (gaps between lines)
    else
        return true; // show gadget's default context menu
        
}

function ContextMenuHide()
{
    if (contextMenuVisible)
    {
        var event = ResolveWindowEvent(event);
        if (event != null && event.button == 2)
            return;

        mouseOverContextMenu = false;
        contextMenuVisible = false;
        contextMenuWrapper.style.display = 'none';
        if (onContextMenuHidden != null)
            onContextMenuHidden();
    }
}

function AutoHideAfterX(miliseconds)
{
    setTimeout("AutoHide()", miliseconds);
    autohideCounter++;
}

function AutoHide()
{
    autohideCounter--;
    if (mouseOverContextMenu)
        AutoHideAfterX(AUTOHIDE_MS)
    else
        if (autohideCounter == 0)
            ContextMenuHide();
}

function PixelsToInt(px)
{
    px = px.replace("px","");
    return parseInt(px);
}

function PlaceContextMenu(x, y)
{
    var gap = 15;
    var contextMenuWidth = PixelsToInt(contextMenuWrapper.style.itemWidth);
    var contextMenuHeight = parseInt(contextMenuWrapper.style.items) * PixelsToInt(contextMenuWrapper.style.itemHeight);
    
    if (x + contextMenuWidth > document.body.clientWidth)
        x -= contextMenuWidth;

    if (y + contextMenuHeight > document.body.clientHeight)
        y -= contextMenuHeight;
    
    if (x < gap)
        x = gap;
        
    if (x > document.body.clientWidth - contextMenuWidth - gap)
        x = document.body.clientWidth - contextMenuWidth - gap;

    contextMenuWrapper.style.left = x + 'px';
    contextMenuWrapper.style.top = y + 'px';    
}

// idea from prototype.js
function $(id)
{
    return document.getElementById(id);
}