var wshShell = new ActiveXObject("WScript.Shell");
var noVersion = "noVersion";
var noCodebase = "noCodebase";
var versionRegisteredByAdmin = noVersion;
var newerVersionInstalledByAdmin = false;

function GetRegisteredVersion(root, progId)
{
    try
    {
        return wshShell.RegRead(root + "\\Software\\Classes\\" + progId + "\\Version\\");
    }
    catch (err)
    {
        return noVersion;
    }
}

function GetRegisteredCodebase(root, clsid, version)
{
    try
    {
        return wshShell.RegRead(root + "\\Software\\Classes\\CLSID\\" + clsid + "\\InprocServer32\\" + version + "\\CodeBase");
    }
    catch (err)
    {
        return noCodebase;
    }
}

function TryToRegDelete(name)
{
    try
    {
        wshShell.RegDelete(name);
    }
    catch (err) { }
}

// Register ActiveX object under specific registry root (simulates regasm registration)
function RegisterAXUnderRoot(root, progId, cls, clsid, assembly, version, codebase)
{
    var regPath = root + "\\Software\\Classes\\";
    var versionRegistered = GetRegisteredVersion(root, progId);
    var codebaseRegistered = GetRegisteredCodebase(root, clsid, version);

    // Register only if there is really something new to register, e.g. new version or new placement of ClipboardManagerAX.dll or its clone
    if (versionRegistered != version || codebaseRegistered != codebase) {
        // Unregister old version if there is one
        UnregisterAXFromRoot(root, progId, clsid);

        // Unregister old version from HKCU if running as elevated admin
        if (root == "HKLM" && HasElevatedAdminRights(progId, clsid))
            UnregisterAXFromRoot("HKCU", progId, clsid);

        // Check whether newer version had been installed by elevated admin
        if (root == "HKCU")
        {
            var versionAdmin = GetRegisteredVersion("HKLM", progId);
            if (versionAdmin != noVersion && version < versionAdmin)
            {
                newerVersionInstalledByAdmin = true;
                versionRegisteredByAdmin = versionAdmin;
            }
        }

        try
        {
            // Now we can register the new version...
            wshShell.RegWrite(regPath + progId + "\\Version\\", version);
            wshShell.RegWrite(regPath + progId + "\\", cls);
            wshShell.RegWrite(regPath + progId + "\\CLSID\\", clsid);
            wshShell.RegWrite(regPath + "CLSID\\" + clsid + "\\", cls);

            wshShell.RegWrite(regPath + "CLSID\\" + clsid + "\\InprocServer32\\", "mscoree.dll");
            wshShell.RegWrite(regPath + "CLSID\\" + clsid + "\\InprocServer32\\ThreadingModel", "Both");
            wshShell.RegWrite(regPath + "CLSID\\" + clsid + "\\InprocServer32\\Class", cls);
            wshShell.RegWrite(regPath + "CLSID\\" + clsid + "\\InprocServer32\\Assembly", assembly);
            wshShell.RegWrite(regPath + "CLSID\\" + clsid + "\\InprocServer32\\RuntimeVersion", "v2.0.50727");
            wshShell.RegWrite(regPath + "CLSID\\" + clsid + "\\InprocServer32\\CodeBase", codebase);

            wshShell.RegWrite(regPath + "CLSID\\" + clsid + "\\InprocServer32\\" + version + "\\Class", cls);
            wshShell.RegWrite(regPath + "CLSID\\" + clsid + "\\InprocServer32\\" + version + "\\Assembly", assembly);
            wshShell.RegWrite(regPath + "CLSID\\" + clsid + "\\InprocServer32\\" + version + "\\RuntimeVersion", "v2.0.50727");
            wshShell.RegWrite(regPath + "CLSID\\" + clsid + "\\InprocServer32\\" + version + "\\CodeBase", codebase);

            wshShell.RegWrite(regPath + "CLSID\\" + clsid + "\\ProgId\\", progId);

            wshShell.RegWrite(regPath + "CLSID\\" + clsid + "\\Implemented Categories\\{62C8FE65-4EBB-45E7-B440-6E39B2CDBF29}\\", "");
        }
        catch (err) { }
    }
}

// Unregister ActiveX object from specified registry root
function UnregisterAXFromRoot(root, progId, clsid)
{
    try
    {
        var versionRegistered = GetRegisteredVersion(root, progId);
        // Do not try to unregister anything what does not exist...
        if (versionRegistered != noVersion)
        {
            var regPath = root + "\\Software\\Classes\\";

            TryToRegDelete(regPath + "CLSID\\" + clsid + "\\Implemented Categories\\{62C8FE65-4EBB-45E7-B440-6E39B2CDBF29}\\");
            TryToRegDelete(regPath + "CLSID\\" + clsid + "\\Implemented Categories\\");

            TryToRegDelete(regPath + "CLSID\\" + clsid + "\\ProgId\\");

            TryToRegDelete(regPath + "CLSID\\" + clsid + "\\InprocServer32\\" + versionRegistered + "\\");
            TryToRegDelete(regPath + "CLSID\\" + clsid + "\\InprocServer32\\");
            TryToRegDelete(regPath + "CLSID\\" + clsid + "\\");

            TryToRegDelete(regPath + progId + "\\Version\\");
            TryToRegDelete(regPath + progId + "\\CLSID\\");
            TryToRegDelete(regPath + progId + "\\");
        }
    }
    catch (err) { }
}

function HasElevatedAdminRights(progId, clsid)
{
    var result = false;
    var key1 = "HKLM\\Software\\Classes\\" + progId + "\\TestAccess\\";
    var key2 = "HKLM\\Software\\Classes\\CLSID\\" + clsid + "\\TestAccess\\";
    var value = "Access Granted";

    try
    {
        // Test whether progId is writable
        wshShell.RegWrite(key1, value);
        result = value == wshShell.RegRead(key1);

        if (result)
        {
            wshShell.RegDelete(key1);
            
            // Test whether clsid is writable
            wshShell.RegWrite(key2, value);
            result = value == wshShell.RegRead(key2);

            if (result)
                wshShell.RegDelete(key2);
        }
    }
    catch (err)
    {
        result = false;
    }

    return result;
}

// Register ActiveX object
//
// Jonathan Abbott: http://forums.microsoft.com/MSDN/ShowPost.aspx?PageIndex=2&SiteID=1&PostID=1091653
// If you want to distribute it with the Gadget, you need to find out what reg entries 
// it creates under HKLM and progammatically put them into HKCU as the Gadget loads.
// I have noticed that this only works if the user is not an elevated Administrator.
// For it to work as an elevated Administrator, you need to register to HKLM.

function RegisterAX(progId, cls, clsid, assembly, version, codebase)
{
    if (HasElevatedAdminRights(progId, clsid))
        RegisterAXUnderRoot("HKLM", progId, cls, clsid, assembly, version, codebase);
    else
        RegisterAXUnderRoot("HKCU", progId, cls, clsid, assembly, version, codebase);
}

// Unregister ActiveX object
function UnregisterAX(progId, clsid)
{
    if (HasElevatedAdminRights(progId, clsid))
        UnregisterAXFromRoot("HKLM", progId, clsid);
    else
        UnregisterAXFromRoot("HKCU", progId, clsid);
}